#include <stdlib.h>
#include <setjmp.h>
#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include "gc.h"

jmp_buf jbuff;

int startgc() {
	int i = 0;
	i = setjmp(jbuff);
	if( i != 0) {
		return 1;
	}
	return 0;
}

unsigned long int test;

void* gcmalloc(size_t size) {
	void* mem;

	mem = malloc(size);
	if(mem == NULL) {
		longjmp(jbuff,1);
	}
		
	return mem;
}

char* gcdup(char* str) {
	char* str2 = (char*) gcmalloc(strlen(str) * sizeof(char) + 1);
	strcpy(str2,str);
	return str2;
}

char* gcsubstr(char* str,int first,int last) {
	char* str2 = (char*)gcmalloc( (last - first + 1) * sizeof(char));
	int i = 0;
	for(;i < (last - first);i++) {
		str2[i] = str[first + i];
	}
	str2[i] = '\0';
	return str2;
}

char* gcend(char* str,int first) {
	return gcsubstr(str,first,strlen(str) + 1);
}

char* gcword(char* str,int num) {
	int word = 0,i = 0,first = 0;
	while(1) {
		while(str[i] == ' ' || str[i] == '\t' || str[i] == '\n') {
			i++;
			first = i;
		}
		if(str[i] == '\0') 
			return NULL;
		while(str[i] != ' ' && str[i] != '\t' && str[i] != '\n' && str[i] != '\0') {
			i++;
		}
		if(word == num) {
			return gcsubstr(str,first,i);
		}
		word++;
	}
}

char* gcstrcat(char* str,char* str2) {
	char* mem = (char*) gcmalloc(sizeof(char) * (strlen(str) + strlen(str2)) + 1);
	strcpy(mem,str);
	strcat(mem,str2);
	return mem;
}

char* gcstrchr(char* str,char a) {
	int i = 0;
	for(;str[i] != a && str[i] != '\0';i++);
	if(str[i] == '\0') return NULL;
	return gcend(str,i+1);
}

char* gcstrrchr(char* str,char a) {
	int j = strlen(str);
	for(;str[j] != a && j >= 0;j--);
	if(j == -1) return NULL;
	return gcsubstr(str,0,j); 
}

void* gccopy(void* mem,size_t size) {
	void* m = gcmalloc(size);
	memcpy(m,mem,size);
	return m;
}
