/***************************************************************************
                          lexer.l  -  description                              
                             -------------------                                         
    begin                : Fri Nov 16 2001                                           
    copyright            : (C) 2001 by Matt Sabins                         
    email                : sabinsmh@clarkson.edu                                     
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   * 
 *                                                                         *
 ***************************************************************************/

%{
	#include <stdlib.h>
	#include <string.h>
	#include "gc.h"
	#include "parser.tab.h"
%}

letter        [a-zA-Z'_''.']
digit         [0-9]+
ident	      	({letter})({letter}|{digit})*
number				({digit}+)

%%

"%eax"	{yylval.sval = (char *)gcdup(yytext);return REG;}
"%ebx"	{yylval.sval = (char *)gcdup(yytext);return REG;}
"%ecx"	{yylval.sval = (char *)gcdup(yytext);return REG;}
"%edx"	{yylval.sval = (char *)gcdup(yytext);return REG;}
"%edi"	{yylval.sval = (char *)gcdup(yytext);return REG;}
"%esi"	{yylval.sval = (char *)gcdup(yytext);return REG;}
"%ebp"	{yylval.sval = (char *)gcdup(yytext);return REG;}
"%esp"	{yylval.sval = (char *)gcdup(yytext);return REG;}
"%ax"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%bx"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%cx"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%dx"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%di"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%si"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%bp"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%sp"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%ah"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%al"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%bh"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%bl"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%ch"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%cl"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%dh"		{yylval.sval = (char *)gcdup(yytext);return REG;}
"%dl"		{yylval.sval = (char *)gcdup(yytext);return REG;}

"%cs:"	{yylval.sval = (char *)gcdup(yytext);return SEG;}
"%ds:"	{yylval.sval = (char *)gcdup(yytext);return SEG;}
"%ss:"	{yylval.sval = (char *)gcdup(yytext);return SEG;}		
"%es:"	{yylval.sval = (char *)gcdup(yytext);return SEG;}		
"%fs:"	{yylval.sval = (char *)gcdup(yytext);return SEG;}	
"%gs:"	{yylval.sval = (char *)gcdup(yytext);return SEG;}		

"("			{return LPAREN;}		
")"			{return RPAREN;}		
","			{return COMMA;}
"$"			{return DOLLAR;}
"-"			{return MINUS;}

{ident}					{yylval.sval = (char *)gcdup(yytext);return IDENT;}
{number}				 {yylval.sval = (char *)gcdup(yytext);return NUM;}
[ \t\r\n]       ;
.		return 0;

%%
