/***************************************************************************
                          mutexlock.c  -  description
                             -------------------
    begin                : Sun Nov 18 2001
    copyright            : (C) 2001 by Matt Sabins
    email                : sabinsmh@clarkson.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <pthread.h>
#include <stdlib.h>
#include <string.h>

#include "gc.h"
#include "parsertypes.h"

memaddr_node_t* parse_mutex_lock(char* str) {
	memaddr_node_t* node = NULL;
	char* call,*fml,*fmu,*fcw;
	if(strcmp("call",call = gcword(str,0))) {
	//	gcfree(call);
		return NULL;
	}
	
//	gcfree(call);
		
	if(!strcmp("pthread_mutex_lock",fml = gcword(str,1))) {
	//	gcfree(fml);
		node = gcmalloc(sizeof(memaddr_node_t));
		memset(node,0,sizeof(memaddr_node_t));
		node->lock_type = L_MUTEX_LOCK;
		return node;
	}
	else if(!strcmp("pthread_mutex_unlock",fmu = gcword(str,1))) {
//		gcfree(fml);	
//		gcfree(fmu);	
		node = gcmalloc(sizeof(memaddr_node_t));
		memset(node,0,sizeof(memaddr_node_t));		
		node->lock_type = L_MUTEX_UNLOCK;
		return node;
		
	}else if(!strcmp("pthread_cond_wait",fcw = gcword(str,1))) {
	//	gcfree(fml);
	//	gcfree(fmu);	
	//	gcfree(fcw);
		node = gcmalloc(sizeof(memaddr_node_t));
		memset(node,0,sizeof(memaddr_node_t));			
		node->lock_type = L_COND_WAIT;
		return node;		
	}
	
//	gcfree(fml);
//	gcfree(fmu);	
//	gcfree(fcw);
	
	return NULL;
}
