/***************************************************************************
                          outputas.c  -  description
                             -------------------
    begin                : Sun Nov 18 2001
    copyright            : (C) 2001 by Matt Sabins
    email                : sabinsmh@clarkson.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

 /*
	L_NOLOCK = 0,
	L_MUTEX_LOCK,
	L_MUTEX_UNLOCK,
	L_COND_WAIT

 */


#include <stdio.h>
#include "parsertypes.h"
#include "gc.h"

extern char * generate_next_localjump();

void output_assembly(FILE* output,memaddr_node_t* node,char* sourcename) {
	char* jump_label1 = "";
	char* jump_label2 = "";
	
//	fprintf(output,"\tpusha\n");
	
//  fprintf(output,"\tpush\t%%esp\n");
//	fprintf(output,"\tpush\t%%ebp\n");	

	fprintf(output,"\tpush\t%%eax\n");
	fprintf(output,"\tpush\t%%ebx\n");
	fprintf(output,"\tpush\t%%ecx\n");
	fprintf(output,"\tpush\t%%edx\n");
	fprintf(output,"\tpush\t%%esi\n");
	fprintf(output,"\tpush\t%%edi\n");
	fprintf(output,"\tpushf\n");
	
	if(node->lock_type == L_NOLOCK) {
		jump_label1 = gcdup(generate_next_localjump());
		jump_label2 = gcdup(generate_next_localjump());
		
		/*

	     	subl    $12, %esp
        pushl   $5
        pushl   $4
        pushl   $3
        pushl   $2
        subl    $4, %esp
        call    pthread_self
        addl    $4, %esp
        movl    %eax, %eax
        pushl   %eax
        call    locksmith_add_memory_access
        addl    $32, %esp
        .stabn 68,0,27,.LM10-main
.LM10:

void locksmith_add_memory_access(pthread_t thread,memaddr_t addr,line_type_e type,int lineno,char* source) __attribute__ ((regparm(3)));

  locksmith_add_memory_access(pthread_self(),2,3,4,5);
			

		*/
		
		fprintf(output,"\tlea\t%s, %%eax\n",node->address);
		fprintf(output,"\tcmpl\t%%ebp, %%eax\n");
		fprintf(output,"\tjl\t%s\n",jump_label1);
		fprintf(output,"\tcmpl\t%%ebp, %%eax\n");
		fprintf(output,"\tjg\t%s\n",jump_label2);
		fprintf(output,"%s:\n",jump_label1);		
		fprintf(output,"\tsubl\t$12, %%esp\n");				
		fprintf(output,"\tpushl\t$%s\n",sourcename);
		fprintf(output,"\tpushl\t$%d\n",node->lineno);
		fprintf(output,"\tpushl\t$%d\n",node->line_type);
		fprintf(output,"\tpush\t%%eax\n");
		fprintf(output,"\tsubl\t$4, %%esp\n");			
		fprintf(output,"\tcall\tpthread_self\n");
		fprintf(output,"\taddl\t$4, %%esp\n");		
		fprintf(output,"\tpush\t%%eax\n");	
		fprintf(output,"\tcall\tlocksmith_add_memory_access\n");
		fprintf(output,"\taddl\t$32, %%esp\n");
		fprintf(output,"%s:\n",jump_label2);
		free(jump_label1);
		free(jump_label2);
		
	}
	else if(node->lock_type == L_MUTEX_LOCK) {
	/*
		Now fastcall interface!!!
	*/
	
		fprintf(output,"\tmovl\t28(%%esp), %%eax\n");
		fprintf(output,"\tcall\tlocksmith_add_lock_to_thread\n");
//void locksmith_add_lock_to_thread(pthread_mutex_t* mutex)
/*
       	pushl	36(%esp)
       	call    locksmith_add_lock_to_thread
       	addl    $16, %esp
*/
	}
	else if(node->lock_type == L_MUTEX_UNLOCK) {
		fprintf(output,"\tmovl\t28(%%esp), %%eax\n");
		fprintf(output,"\tcall\tlocksmith_remove_lock_from_thread\n");
	}
	else if(node->lock_type == L_COND_WAIT) {
		fprintf(output,"\tmovl\t32(%%esp), %%eax\n");
		fprintf(output,"\tcall\tlocksmith_add_lock_to_thread\n");
	}
	
	fprintf(output,"\tpopf\n");	
	fprintf(output,"\tpop\t%%edi\n");
	fprintf(output,"\tpop\t%%esi\n");
	fprintf(output,"\tpop\t%%edx\n");
	fprintf(output,"\tpop\t%%ecx\n");
	fprintf(output,"\tpop\t%%ebx\n");
	fprintf(output,"\tpop\t%%eax\n");	
	
//	fprintf(output,"\tpop\t%%ebp\n");
//	fprintf(output,"\tpop\t%%esp\n");	
}
