/***************************************************************************
                          parseinstr.c  -  description
                             -------------------
    begin                : Thu Nov 15 2001
    copyright            : (C) 2001 by Matt Sabins
    email                : sabinsmh@clarkson.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdlib.h>
#include <string.h>
#include "parseinstr.h"

#define DLB_RW_INSTR_SIZE 56

char dbl_rw_instr [DLB_RW_INSTR_SIZE][7] = {
"adcb",
"adcw",
"adcl",
"addb",
"addw",
"addl",
"andb",
"andw",
"andl",
"imulw",
"imull",
"movb",
"movw",
"movl",
"movsbw",
"movsbl",
"movswl",
"movzbw",
"movzbl",
"movzwl",
"orb",
"orw",
"orl",
"rclb",
"rclw",
"rcll",
"rcrb",
"rcrw",
"rcrl",
"rolb",
"rolw",
"roll",
"rorb",
"rorw",
"rorl",
"salb",
"salw",
"sall",
"sarb",
"sarw",
"sarl",
"sbbb",
"sbbw",
"sbbl",
"shlb",
"shlw",
"shll",
"shrb",
"shrw",
"shrl",
"subb",
"subw",
"subl",
"xorb",
"xorw",
"xorl"
};

int is_dbl_rw_instr(char* str) {
	return (NULL != bsearch(str,dbl_rw_instr,DLB_RW_INSTR_SIZE,7,strcmp));
}

/*
	It has two arguments but it only reads.
*/

#define DLB_RONLY_INSTR_SIZE 18

char dbl_ronly_instr [DLB_RONLY_INSTR_SIZE][7] = {
"bsfw",
"bsfl",
"bsrw",
"bsrl",
"btw",
"btl",
"btcw",
"btcl",
"btrw",
"btrl",
"btsw",
"btsl",
"cmpb",
"cmpw",
"cmpl",
"testb",
"testw",
"testl"
};

int is_dbl_ronly_instr(char* str) {
	return (NULL != bsearch(str,dbl_ronly_instr,DLB_RONLY_INSTR_SIZE,7,strcmp));
}

/*
  both read and write to memory
	samething but both write to addr.
*/

#define DLB_WONLY_INSTR_SIZE 6

char dbl_wonly_instr [DLB_WONLY_INSTR_SIZE][7] = {
"xaddb",
"xaddw",
"xaddl",
"xchgb",
"xchgw",
"xchgl"
};

int is_dbl_wonly_instr(char* str) {
	return (NULL != bsearch(str,dbl_wonly_instr,DLB_WONLY_INSTR_SIZE,7,strcmp));
}


#define SNGL_READ_INSTR_SIZE 14

char sngl_read_instr[SNGL_READ_INSTR_SIZE][7] = {
"divb",
"divw",
"divl",
"idivb",
"idivw",
"idivl",
"imulb",
"imulw",
"imull",
"mulb",
"mulw",
"mull",
"pushw",
"pushl"
};

int is_sngl_read_instr(char* str) {
	return (NULL != bsearch(str,sngl_read_instr,SNGL_READ_INSTR_SIZE,7,strcmp));
}


#define SNGL_WRITE_INSTR 14

char sngl_write_instr[SNGL_WRITE_INSTR][7] = {
"decb",
"decw",
"decl",
"incb",
"incw",
"incl",
"negb",
"negw",
"negl",
"notb",
"notw",
"notl",
"popw",
"popl"
};

int is_sngl_write_instr(char* str) {
	return (NULL != bsearch(str,sngl_write_instr,SNGL_WRITE_INSTR,7,strcmp));
}

