/***************************************************************************
                          parser.h  -  description
                             -------------------
    begin                : Sat Nov 17 2001
    copyright            : (C) 2001 by Matt Sabins
    email                : sabinsmh@clarkson.edu
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef _PARSER_H_
#define _PARSER_H_

typedef enum {
	false = 0,
	true = 1
}bool;

typedef enum {
	L_STATIC_WRITE,		//A write to a static named data variable
	L_STATIC_READ,		//A read from a static named data variable
	L_DYNAMIC_WRITE,	//A write to a pointered to variable.
	L_DYNAMIC_READ,		//A read from a pointed variable.
}line_type_e;

typedef enum {
	L_NOLOCK = 0,
	L_MUTEX_LOCK,
	L_MUTEX_UNLOCK,
	L_COND_WAIT
} lock_type_e;

typedef struct memaddr_node_s {
	lock_type_e lock_type;
	int position;
	char* address;
	bool is_static;
	bool is_valid;
	line_type_e line_type;
	int lineno;
	int source_lineno;
	struct memaddr_node_s	* next;	
} memaddr_node_t;

memaddr_node_t* parse_mnemonic(char* str);	
memaddr_node_t* parse_mutex_lock(char* str);

//return the memory access node if its a valid memory access
//other wise null.
							

#endif

